/*
 * systemtime.h
 *
 *
 */

#ifndef SYSTEM_TIME_H_
#define SYSTEM_TIME_H_

#include <stdint.h>
#include <cocoos.h>


class TimeProvider {
public:
    virtual uint32_t getTime() = 0;
};

class SystemTime : public TimeProvider {

public:
    SystemTime();
    ~SystemTime();

    void create(uint8_t prio);
    virtual uint32_t getTime();

private:
    static void task();
    static uint32_t systemTime;
};


#endif /* SYSTEM_TIME_H_ */
