/*
 * tcpif.h
 *
 *
 */

#ifndef TCPIF_H
#define TCPIF_H

#include <stdint.h>
#include <inc/queue.h>
#include <lwip/err.h>
#include <tcp_defs.h>


typedef utils::Queue<tcpPacket> tcpPacketQueue;

class tcpif {
public:
    tcpif();
    ~tcpif();
    void create(uint8_t prio);
    static void task();
    uint8_t init();
private:
    bool checkMessage(tcpPacket *msg);
    static err_t accept(void *arg, struct tcp_pcb *newpcb, err_t err);
    static err_t recv(void *arg, struct tcp_pcb *tpcb, struct pbuf *p, err_t err);
    static void error(void *arg, err_t err);
    static err_t poll(void *arg, struct tcp_pcb *tpcb);
    static tcpPacketQueue tq;
};





#endif /* TCPIF_H */
